From 38f1673cdfb522e4c0d22c2ca57b34869f711e71 Mon Sep 17 00:00:00 2001
From: Amit Langote <amitlan@postgresql.org>
Date: Thu, 18 Sep 2025 15:00:21 +0900
Subject: [PATCH v5] Fix EPQ crash from missing partition pruning state in
 EState

Commit bb3ec16e14 moved partition pruning metadata into PlannedStmt.
At executor startup this metadata is used to initialize the EState
fields es_part_prune_infos, es_part_prune_states, and
es_part_prune_results.  EvalPlanQualStart() failed to copy those
fields into the child EState, causing NULL dereference when Append
ran partition pruning during a recheck. This can occur with DELETE
or UPDATE on partitioned tables that use runtime pruning, e.g. with
generic plans.

Fix by copying all partition pruning state into the EPQ estate.

Add an isolation test that reproduces the crash with concurrent
UPDATE and DELETE on a partitioned table, where the DELETE session
hits the crash during its EPQ recheck after the UPDATE commits.

Bug: #19056
Reported-by: Fei Changhong <feichanghong@qq.com>
Diagnozed-by: Fei Changhong <feichanghong@qq.com>
Author: David Rowley <dgrowleyml@gmail.com>
Co-authored-by: Amit Langote <amitlangote09@gmail.com>
Discussion: https://postgr.es/m/19056-a677cef9b54d76a0%40postgresql.org
---
 src/backend/executor/execMain.c                |  9 +++++++++
 src/test/isolation/expected/eval-plan-qual.out | 18 +++++++++++++++++-
 src/test/isolation/specs/eval-plan-qual.spec   | 18 ++++++++++++++++++
 3 files changed, 44 insertions(+), 1 deletion(-)

diff --git a/src/backend/executor/execMain.c b/src/backend/executor/execMain.c
index ff12e2e1364..831c55ce787 100644
--- a/src/backend/executor/execMain.c
+++ b/src/backend/executor/execMain.c
@@ -3084,6 +3084,15 @@ EvalPlanQualStart(EPQState *epqstate, Plan *planTree)
 	 */
 	rcestate->es_unpruned_relids = parentestate->es_unpruned_relids;
 
+	/*
+	 * Also make the PartitionPruneInfo and the results of pruning available.
+	 * These need to match exactly so that we initialize all the same Append
+	 * and MergeAppend subplans as the parent did.
+	 */
+	rcestate->es_part_prune_infos = parentestate->es_part_prune_infos;
+	rcestate->es_part_prune_states = parentestate->es_part_prune_states;
+	rcestate->es_part_prune_results = parentestate->es_part_prune_results;
+
 	/*
 	 * Initialize private state information for each SubPlan.  We must do this
 	 * before running ExecInitNode on the main query tree, since
diff --git a/src/test/isolation/expected/eval-plan-qual.out b/src/test/isolation/expected/eval-plan-qual.out
index 3d31d0f84e5..485cf0eb912 100644
--- a/src/test/isolation/expected/eval-plan-qual.out
+++ b/src/test/isolation/expected/eval-plan-qual.out
@@ -1,4 +1,4 @@
-Parsed test spec with 3 sessions
+Parsed test spec with 5 sessions
 
 starting permutation: wx1 wx2 c1 c2 read
 step wx1: UPDATE accounts SET balance = balance - 200 WHERE accountid = 'checking' RETURNING balance;
@@ -1457,3 +1457,19 @@ step sysmerge2:
 step c1: COMMIT;
 step sysmerge2: <... completed>
 step c2: COMMIT;
+
+starting permutation: s4pp1 s4pp2 s5pp1 s5pp2 s5pp3 s4pp3 s5pp4 s5pp5
+step s4pp1: BEGIN;
+step s4pp2: UPDATE another_parttbl SET b = b + 1 WHERE a = 1;
+step s5pp1: SET plan_cache_mode TO force_generic_plan;
+step s5pp2: PREPARE epd AS DELETE FROM another_parttbl WHERE a = $1;
+step s5pp3: EXECUTE epd(1); <waiting ...>
+step s4pp3: COMMIT;
+step s5pp3: <... completed>
+step s5pp4: SELECT count(*) FROM another_parttbl;
+count
+-----
+    0
+(1 row)
+
+step s5pp5: DEALLOCATE epd;
diff --git a/src/test/isolation/specs/eval-plan-qual.spec b/src/test/isolation/specs/eval-plan-qual.spec
index c6eee685586..b9bb4c75e8c 100644
--- a/src/test/isolation/specs/eval-plan-qual.spec
+++ b/src/test/isolation/specs/eval-plan-qual.spec
@@ -343,6 +343,21 @@ step multireadwcte	{
 
 teardown	{ COMMIT; }
 
+# Exercise run-time partition pruning code in an EPQ recheck
+session s4
+
+step s4pp1 { BEGIN; }
+step s4pp2 { UPDATE another_parttbl SET b = b + 1 WHERE a = 1; }
+step s4pp3 { COMMIT; }
+
+session s5
+
+step s5pp1 { SET plan_cache_mode TO force_generic_plan; }
+step s5pp2 { PREPARE epd AS DELETE FROM another_parttbl WHERE a = $1; }
+step s5pp3 { EXECUTE epd(1); }
+step s5pp4 { SELECT count(*) FROM another_parttbl; }
+step s5pp5 { DEALLOCATE epd;}
+
 # test that normal update follows update chains, and reverifies quals
 permutation wx1 wx2 c1 c2 read
 permutation wy1 wy2 c1 c2 read
@@ -415,3 +430,6 @@ permutation simplepartupdate_noroute complexpartupdate_doesnt_route c1 c2 read_p
 
 permutation sys1 sysupd2 c1 c2
 permutation sys1 sysmerge2 c1 c2
+
+# Exercise run-time partition pruning code in an EPQ recheck
+permutation s4pp1 s4pp2 s5pp1 s5pp2 s5pp3 s4pp3 s5pp4 s5pp5
-- 
2.43.0

